#ifndef PLAY_HPP
#define PLAY_HPP

#include <Basis/Screen.hpp>
#include <vector>

using namespace std;

#define MIN(x,y) ((x) < (y) ? (x) : (y))

#define BOARD_WIDTH 20
#define BOARD_HEIGHT 10
#define BLOCK_WIDTH (Graphics::screen.x / (float) BOARD_WIDTH)
#define BLOCK_HEIGHT (Graphics::screen.y / (float) BOARD_HEIGHT)
#define BLOCK_BORDER (0.1 * MIN(BLOCK_WIDTH, BLOCK_HEIGHT))
#define MINE (-1)
#define HIDDEN (-2)

class Play : public Screen {
private:
    // Entries: MINE, HIDDEN, or # of adjacent bombs
    int revealed[BOARD_WIDTH][BOARD_HEIGHT];
    
    // Change display while a square is being clicked
    int revealing_x, revealing_y;

    bool game_over;

    // Network stuff
    int sock;
	vector< uint8_t > write_buffer;
	vector< uint8_t > read_buffer;

    void reset_board();
    void send_message(string message, char type);
    void reveal_squares(int x, int y);
public:
	Play(char *hostname, char *port, char *game_name);
	virtual ~Play();
	virtual void draw();
	virtual void update(float elapsed_time);
	virtual void handle_event(SDL_Event const &event);
};

#endif //PLAY_HPP
